<template>
    <div class="v-select" v-click-outside="onClickOutside">
        <button type="button" @click="onClick"
            class="py-2.5 px-5 min-w-20 mr-2 mb-2 text-sm font-medium text-gray-900 focus:outline-none bg-white rounded-full border border-gray-200 hover:bg-gray-100 hover:text-primary focus:z-10">
            {{ modelValue }}
            <fa-icon :class="{ 'rotate-180': open }" icon="fa-solid fa-angle-down ml-2" class="duration-500" />
        </button>
        <div v-show="open" class="z-10 bg-white rounded divide-y divide-gray-100 shadow absolute">
            <ul class="text-sm text-gray-700 dark:text-gray-200" aria-labelledby="dropdownDefault">
                <li v-for="(item, i) in items" :key="i">
                    <a @click="onChangeValue(item.value)" href="#"
                        class="block py-2 px-4 hover:bg-gray-100 dark:hover:bg-gray-600 dark:hover:text-white">{{
                                item.name
                        }}</a>
                </li>
            </ul>
        </div>
    </div>
</template>

<script>
export default {
    name: 'VSelect',
    props: {
        modelValue: String,
        items: {
            type: Array,
            default: () => []
        }
    },
    data: () => ({
        open: false
    }),
    methods: {
        onChangeValue(value) {
            this.open = false;
            this.$emit('change', value)
        },
        onClick() {
            this.open = !this.open;
        },
        onClickOutside() {
            this.open = false;
        }
    }
}
</script>